<?php
/**
 * 易优CMS
 * ============================================================================
 * 版权所有 2016-2028 海南赞赞网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.eyoucms.com
 * ----------------------------------------------------------------------------
 * 如果商业用途务必到官方购买正版授权, 以免引起不必要的法律纠纷.
 * ============================================================================
 * Author: 小虎哥 <1105415366@qq.com>
 * Date: 2018-4-3
 */

namespace app\admin\controller;

use think\Db;
use app\common\logic\ArctypeLogic;

class Archives extends Base
{
    // 允许发布文档的模型ID
    public $allowReleaseChannel = array();
    
    public function _initialize() {
        parent::_initialize();
        $this->allowReleaseChannel = config('global.allow_release_channel');
    }

    /**
     * 发布内容
     */
    public function release()
    {
        if (IS_POST) {
            $post = I('post.');
            $typeid = isset($post['typeid']) ? $post['typeid'] : 0;
            if (!empty($post) && $typeid > 0) {
                $row = db('arctype')
                    ->field('b.ctl_name,b.id')
                    ->alias('a')
                    ->join('__CHANNELTYPE__ b', 'a.current_channel = b.id', 'LEFT')
                    ->where('a.id', 'eq', $typeid)
                    ->find();
                $ctl_name = $row['ctl_name'];
                $jumpUrl = "/index.php?m=".MODULE_NAME."&c={$ctl_name}&a=add&typeid={$typeid}";

                /*针对不支持发布文档的模型*/
                if (!in_array($row['id'], $this->allowReleaseChannel)) {
                    $this->error('该栏目不支持发布文档！', U('Archives/release'));
                    exit;
                }
                /*-----end*/

                header('Location: '.$jumpUrl);
            }
            exit;
        }

        /*允许发布文档列表的栏目*/
        $select_html = allow_release_arctype();
        $this->assign('select_html',$select_html);
        /*--end*/

        /*不允许发布文档的模型ID，用于JS判断*/
        $js_allow_channel_arr = '[';
        foreach ($this->allowReleaseChannel as $key => $val) {
            if ($key > 0) {
                $js_allow_channel_arr .= ',';
            }
            $js_allow_channel_arr .= $val;
        }
        $js_allow_channel_arr = $js_allow_channel_arr.']';
        $this->assign('js_allow_channel_arr', $js_allow_channel_arr);
        /*--end*/

        return $this->fetch();
    }

    public function ajax_get_arctype()
    {
        $pid = I('pid/d');
        $html = '';
        $status = 0;
        if (0 < $pid) {
            $map = array(
                'current_channel'    => array('IN', $this->allowReleaseChannel),
                'parent_id' => $pid,
            );
            $row = model('Arctype')->getAll('id,typename', $map, 'id');
            if (!empty($row)) {
                $status = 1;
                $html = '<option value="0">请选择栏目…</option>';
                foreach ($row as $key => $val) {
                    $html .= '<option value="'.$val['id'].'">'.$val['typename'].'</option>';
                }
            }
        }

        respose(array(
            'status'    => $status,
            'msg'   => $html,
        ));
    }
}