<?php
/**
 * 易优CMS
 * ============================================================================
 * 版权所有 2016-2028 海南赞赞网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.eyoucms.com
 * ----------------------------------------------------------------------------
 * 如果商业用途务必到官方购买正版授权, 以免引起不必要的法律纠纷.
 * ============================================================================
 * Author: 小虎哥 <1105415366@qq.com>
 * Date: 2018-4-3
 */

$home_route = array();
$seo_pseudo = tpCache('seo.seo_pseudo');
$ui_set = I('get.ui_set/s', 'off');
if ($seo_pseudo == 3 && $ui_set != 'on') {
  $home_route = [
    // 文章模型伪静态
    'article$' => ['home/Article/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'article/<tid>$' => ['home/Article/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'article/<dirname>/<aid>$' => ['home/Article/view',['method' => 'get', 'ext' => 'html'],'cache'=>1],
    // 产品模型伪静态
    'product$' => ['home/Product/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'product/<tid>$' => ['home/Product/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'product/<dirname>/<aid>$' => ['home/Product/view',['method' => 'get', 'ext' => 'html'],'cache'=>1],
    // 图集模型伪静态
    'images$' => ['home/Images/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'images/<tid>$' => ['home/Images/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'images/<dirname>/<aid>$' => ['home/Images/view',['method' => 'get', 'ext' => 'html'],'cache'=>1],
    // 下载模型伪静态
    'download$' => ['home/Download/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'download/<tid>$' => ['home/Download/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'download/<dirname>/<aid>$' => ['home/Download/view',['method' => 'get', 'ext' => 'html'],'cache'=>1],
    'downfile/<id>/<uhash>$' => ['home/Download/downfile',['method' => 'get', 'ext' => 'html'],'cache'=>1],
    // 简介模型伪静态
    'about$' => ['home/About/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'about/<tid>$' => ['home/About/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'about/<dirname>/<aid>$' => ['home/About/view',['method' => 'get', 'ext' => 'html'],'cache'=>1],
    // 标签伪静态
    'tags$' => ['home/Tags/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'tags/<tagid>$' => ['home/Tags/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    // 留言模型
    'guestbook$' => ['home/Guestbook/index',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'guestbook/<tid>$' => ['home/Guestbook/lists',['method' => 'get', 'ext' => 'html'], 'cache'=>1],
    'guestbook/submit$' => ['home/Guestbook/submit',['method' => 'post', 'ext' => 'html'], 'cache'=>1],
  ];
}

$route = [
    '__pattern__' => [
        'tid' => '\w+',
        'aid' => '\d+',
    ],
    '__alias__' => [],
    '__domain__' => [],
];

$route = array_merge($route, $home_route);

return $route;
